/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.jiuqi.util.StringUtils
 *  com.jiuqi.util.chinese.ChineseDouble
 */
package com.jiuqi.grid;

import com.jiuqi.grid.CellDataProcessorIntf;
import com.jiuqi.grid.CellDataProperty;
import com.jiuqi.grid.CellDataPropertyIntf;
import com.jiuqi.grid.GridCell;
import com.jiuqi.grid.NumberCellPropertyIntf;
import com.jiuqi.util.StringUtils;
import com.jiuqi.util.chinese.ChineseDouble;
import java.io.Serializable;
import java.text.DecimalFormat;

public class NumberCellProperty
implements NumberCellPropertyIntf,
CellDataProcessorIntf,
Serializable {
    protected CellDataPropertyIntf cellDataProperty;

    public NumberCellProperty(CellDataPropertyIntf dataProperty) {
        this.cellDataProperty = dataProperty;
    }

    public NumberCellProperty(GridCell cell) {
        this(new CellDataProperty(cell));
    }

    public CellDataPropertyIntf getCellDataProperty() {
        return this.cellDataProperty;
    }

    public int getDecimal() {
        return this.cellDataProperty.getDataFlag();
    }

    public void setDecimal(int value) {
        if (value <= 15) {
            if (value < 0) {
                value = 0;
            }
        } else {
            throw new IllegalArgumentException("错误设置了数字的小数位数，应该在0-15之间！");
        }
        this.cellDataProperty.setDataFlag((byte)value);
    }

    public int getPrecision() {
        return this.cellDataProperty.getDataProperty() & 0x1F;
    }

    public void setPrecision(int value) {
        if (value < 0 || value > 32) {
            throw new IllegalArgumentException("错误设置了数字的精度，应该在0-32之间！");
        }
        int data = value & 0x1F;
        this.cellDataProperty.setDataProPerty((short)(this.cellDataProperty.getDataProperty() & 0xFFFFFFE0 | data));
    }

    public boolean getThoundsMark() {
        return (this.cellDataProperty.getDataProperty() & 0x8000) != 0;
    }

    public void setThoundsMarks(boolean value) {
        if (value) {
            this.cellDataProperty.setDataProPerty((short)(this.cellDataProperty.getDataProperty() | 0x8000));
        } else {
            this.cellDataProperty.setDataProPerty((short)(this.cellDataProperty.getDataProperty() & 0xFFFF7FFF));
        }
    }

    public boolean getBracketNegative() {
        return (this.cellDataProperty.getDataProperty() & 0x4000) != 0;
    }

    public void setBracketNegative(boolean value) {
        if (value) {
            this.cellDataProperty.setDataProPerty((short)(this.cellDataProperty.getDataProperty() | 0x4000));
        } else {
            this.cellDataProperty.setDataProPerty((short)(this.cellDataProperty.getDataProperty() & 0xFFFFBFFF));
        }
    }

    public boolean getWarningNegative() {
        return (this.cellDataProperty.getDataProperty() & 0x2000) != 0;
    }

    public void setWarningNegative(boolean value) {
        if (value) {
            this.cellDataProperty.setDataProPerty((short)(this.cellDataProperty.getDataProperty() | 0x2000));
        } else {
            this.cellDataProperty.setDataProPerty((short)(this.cellDataProperty.getDataProperty() & 0xFFFFDFFF));
        }
    }

    public boolean getChineseNumber() {
        return (this.cellDataProperty.getDataProperty() & 0x1000) != 0;
    }

    public void setChineseNumber(boolean value) {
        if (value) {
            this.cellDataProperty.setDataProPerty((short)(this.cellDataProperty.getDataProperty() | 0x1000));
        } else {
            this.cellDataProperty.setDataProPerty((short)(this.cellDataProperty.getDataProperty() & 0xFFFFEFFF));
        }
    }

    public boolean getBigChineseChar() {
        return (this.cellDataProperty.getDataProperty() & 0x800) != 0;
    }

    public void setBigChineseChar(boolean value) {
        if (value) {
            this.cellDataProperty.setDataProPerty((short)(this.cellDataProperty.getDataProperty() | 0x800));
        } else {
            this.cellDataProperty.setDataProPerty((short)(this.cellDataProperty.getDataProperty() & 0xFFFFF7FF));
        }
    }

    public boolean getIsPercent() {
        if (this.cellDataProperty.getDataType() == 2) {
            return (this.cellDataProperty.getDataProperty() & 0x400) != 0;
        }
        return false;
    }

    public void setIsPercent(boolean value) {
        if (this.cellDataProperty.getDataType() == 2) {
            if (value) {
                this.cellDataProperty.setDataProPerty((short)(this.cellDataProperty.getDataProperty() | 0x400));
            } else {
                this.cellDataProperty.setDataProPerty((short)(this.cellDataProperty.getDataProperty() & 0xFFFFFBFF));
            }
        }
    }

    public String getEditText(String storeText) {
        return storeText;
    }

    public String getShowText(String storeText) {
        if (storeText != null) {
            String showText = null;
            if (storeText == "") {
                showText = "";
            } else {
                double value;
                storeText = StringUtils.eliminate((String)storeText, (char)',');
                try {
                    value = Double.parseDouble(storeText);
                }
                catch (NumberFormatException numberFormatException) {
                    return storeText;
                }
                boolean isNegtive = value < 0.0;
                boolean isPercent = this.getIsPercent();
                boolean showThoundsMark = this.getThoundsMark();
                if (isNegtive) {
                    value = -value;
                }
                if (isPercent && !showThoundsMark) {
                    value *= 100.0;
                    this.setDecimal(this.getDecimal() - 2);
                } else if (isPercent && showThoundsMark) {
                    value *= 1000.0;
                    this.setDecimal(this.getDecimal() - 3);
                }
                int decimal = this.getDecimal();
                if (decimal == 15) {
                    decimal = 0;
                }
                value = NumberCellProperty.trimDouble(value, this.getDecimal());
                if (!this.getChineseNumber()) {
                    showText = NumberCellProperty.formatNumberString(value, this.getDecimal(), this.getThoundsMark());
                    if (isPercent && !showThoundsMark) {
                        showText = String.valueOf(showText) + "%";
                    }
                    if (isPercent && showThoundsMark) {
                        showText = String.valueOf(showText) + "‰";
                    }
                    if (isNegtive) {
                        showText = this.getBracketNegative() ? "(" + showText + ")" : "-" + showText;
                    }
                } else {
                    ChineseDouble cnDouble;
                    if (isPercent && !showThoundsMark) {
                        cnDouble = new ChineseDouble(value / 100.0);
                        showText = cnDouble.getPercentForm(this.getDecimal(), true, this.getBigChineseChar());
                    }
                    if (isPercent && showThoundsMark) {
                        cnDouble = new ChineseDouble(value / 1000.0);
                        showText = cnDouble.getPermillageForm(this.getDecimal(), true, this.getBigChineseChar());
                    }
                    if (!isPercent) {
                        cnDouble = new ChineseDouble(value);
                        showText = !showThoundsMark ? cnDouble.chineseValue(this.getDecimal(), false, this.getBigChineseChar()) : cnDouble.chineseValue(this.getDecimal(), true, this.getBigChineseChar());
                    }
                    if (isNegtive) {
                        showText = "（负）" + showText;
                    }
                }
                if (isPercent) {
                    this.setDecimal(this.getDecimal() + (showThoundsMark ? 3 : 2));
                }
            }
            return showText;
        }
        throw new IllegalArgumentException("不能解析指向null的字符串为数字！");
    }

    public String parseEditText(String editText) {
        double value = Double.parseDouble(editText);
        return NumberCellProperty.formatNumberString(value, this.getDecimal(), false);
    }

    public String parseShowText(String showText) {
        String value = "";
        if (!this.getChineseNumber()) {
            value = showText;
        } else {
            try {
                value = ChineseDouble.valueOf((String)showText);
            }
            catch (Exception exception) {
                throw new IllegalArgumentException("中文数值有错误，解析失败");
            }
        }
        double dbValue = Double.parseDouble(value);
        return NumberCellProperty.formatNumberString(dbValue, this.getDecimal(), this.getThoundsMark());
    }

    private static double trimDouble(double source, int frcLength) {
        if (frcLength < 0) {
            frcLength = 0;
        }
        double des = source;
        int multiplier = (int)Math.exp(Math.log(10.0) * (double)frcLength);
        double temp = Math.round(source * (double)multiplier);
        des = temp / (double)multiplier;
        return des;
    }

    private static String formatNumberString(double value, int decimal, boolean thoundsMark) {
        DecimalFormat df = new DecimalFormat();
        df.setGroupingUsed(false);
        if (thoundsMark) {
            df.setGroupingSize(3);
            df.setGroupingUsed(true);
        }
        if (decimal >= 0) {
            df.setMaximumFractionDigits(decimal);
            df.setMinimumFractionDigits(decimal);
        }
        return df.format(value);
    }
}

